Commit cf72f204 authored by Martin Pool's avatar Martin Pool

Improved test framework and test for hardlink handling

parent d479210c
#! /bin/sh #! /bin/sh
# Copyright (C) 2001 by Martin Pool <mbp@samba.org> # Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
# This program is free software; you can redistribute it and/or modify # This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version # it under the terms of the GNU General Public License version
...@@ -160,16 +160,25 @@ missing=0 ...@@ -160,16 +160,25 @@ missing=0
passed=0 passed=0
failed=0 failed=0
scratchdir="`pwd`"/testtmp # Prefix for scratch directory. We create separate directories for
echo " scratchdir=$scratchdir" # each test case, so that they can be left behind in case of failure
# to aid investigation.
scratchbase="`pwd`"/testtmp
echo " scratchbase=$scratchbase"
suitedir="$srcdir/testsuite" suitedir="$srcdir/testsuite"
export scratchdir suitedir export scratchdir suitedir
clean_scratch() { prep_scratch() {
[ -d "$scratchdir" ] && rm -rf "$scratchdir" [ -d "$scratchdir" ] && rm -rf "$scratchdir"
mkdir "$scratchdir" mkdir "$scratchdir"
return 0
}
discard_scratch() {
[ -d "$scratchdir" ] && rm -rf "$scratchdir"
return 0
} }
if [ "x$whichtests" = x ] if [ "x$whichtests" = x ]
...@@ -179,32 +188,38 @@ fi ...@@ -179,32 +188,38 @@ fi
for testscript in $suitedir/$whichtests for testscript in $suitedir/$whichtests
do do
testbase=`echo $testscript | sed 's!.*/!!'` testbase=`echo $testscript | sed 's!.*/!!' | sed -e 's/.test\$//'`
scratchdir="$scratchbase.$testbase"
echo "----- $testbase starting" echo "----- $testbase starting"
clean_scratch prep_scratch
if sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1 set +e
then sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
result=$?
set -e
case $result in
0)
echo "----- $testbase completed successfully" echo "----- $testbase completed successfully"
passed=`expr $passed + 1` passed=`expr $passed + 1`
else discard_scratch
case $? in ;;
77) 77)
echo "----- $testbase skipped" echo "----- $testbase skipped"
skipped=`expr $skipped + 1` skipped=`expr $skipped + 1`
;; discard_scratch
*) ;;
echo "----- $testbase failed: log follows" *)
cat "$scratchdir/test.log" echo "----- $testbase failed: log follows"
echo "----- $testbase log ends" cat "$scratchdir/test.log"
failed=`expr $failed + 1` echo "----- $testbase log ends"
if [ "x$nopersist" = "xyes" ] failed=`expr $failed + 1`
then if [ "x$nopersist" = "xyes" ]
exit 1 then
fi exit 1
esac fi
fi esac
done done
echo '------------------------------------------------------------' echo '------------------------------------------------------------'
......
...@@ -31,7 +31,7 @@ ln "$name1" "$name2" || fail "Can't create hardlink" ...@@ -31,7 +31,7 @@ ln "$name1" "$name2" || fail "Can't create hardlink"
ln "$name2" "$name3" || fail "Can't create hardlink" ln "$name2" "$name3" || fail "Can't create hardlink"
cp "$name2" "$name4" || fail "Can't copy file" cp "$name2" "$name4" || fail "Can't copy file"
checkit "rsync -aH \"$fromdir/\" \"$todir/\"" "$fromdir" "$todir" checkit "rsync -aHvv \"$fromdir/\" \"$todir/\"" "$fromdir" "$todir"
exit 0 exit 0
# last [] may have failed but if we get here then we've won # last [] may have failed but if we get here then we've won
......
...@@ -135,35 +135,31 @@ makepath () { ...@@ -135,35 +135,31 @@ makepath () {
# there are any difference. If there are, explain them. # there are any difference. If there are, explain them.
checkit() { checkit() {
log=${LOG}
failed= failed=
# the log accumulates all output; we only display it if there
# is a problem.
echo "Running: \"$1\"" >${log} # We can just write everything to stdout/stderr, because the
echo "">>${log} # wrapper hides it unless there is a problem.
eval "$1" >>${log} 2>&1
echo "Running: \"$1\""
eval "$1"
status=$? status=$?
if [ $status != 0 ]; then if [ $status != 0 ]; then
failed="YES"; failed="YES";
fi fi
echo "-------------">>${log} echo "-------------"
echo "check how the files compare with diff:">>${log} echo "check how the files compare with diff:"
echo "">>${log} echo ""
diff -cr $2 $3 >>${log} 2>&1 || failed=YES diff -cr $2 $3 || failed=YES
echo "-------------">>${log} echo "-------------"
echo "check how the directory listings compare with diff:">>${log} echo "check how the directory listings compare with diff:"
echo "">>${log} echo ""
( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from 2>>${log} ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from
( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to 2>>${log} ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to
diff -c ${TMP}/ls-from ${TMP}/ls-to >>${log} 2>&1 || failed=YES diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
if [ -z "${failed}" ] ; then if [ -z "${failed}" ] ; then
rm $log
return 0 return 0
else else
cat ${log}
rm ${log}
return 1 return 1
fi fi
} }
......
Markdown is supported
0% or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment